;;;    LISTVAR.LSP
;;;    Copyright  1999 by AfraLisp.
;;;
;;;    Your use of this software is governed by the terms and conditions of the
;;;    License Agreement you accepted prior to installation of this software.
;;;    Please note that pursuant to the License Agreement for this software,
;;;    "[c]opying of this computer program or its documentation except as
;;;    permitted by this License is copyright infringement under the laws of
;;;    your country.  If you copy this computer program without permission of
;;;    AfraLisp, you are violating the law."
;;;
;;;    AFRALISP PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
;;;    AFRALISP SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
;;;    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AFRALISP
;;;    DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;;;    UNINTERRUPTED OR ERROR FREE.
;;;
;;;    Use, duplication, or disclosure by the U.S. Government is subject to
;;;    restrictions set forth in FAR 52.227-19 (Commercial Computer
;;;    Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
;;;    (Rights in Technical Data and Computer Software), as applicable.
;;;
;;;  ----------------------------------------------------------------
;;;
;;;It is very important when writing AutoLISP routines to declare all
;;;your Local Variables. This prevents your variables stepping on other
;;;variables of the same name from other routines.
;;;It often happens though, that on completion of your application, it
;;;can be quite difficult to remember and locate all the variables that you
;;;have used. This application will list all the un-declared variables and all
;;;functions used within your routine.
;;;
;;;For Usage refer to ListVar.Htm.
;;;
;;;  ----------------------------------------------------------------
;;;
;;;Files included with this application :
;;;
;;;		ListVar.Lsp
;;;		ListVar.Dcl
;;;		ListVar.Txt
;;;		ListVar.Htm
;;;		Info.Htm
;;;		Lisp57a.Gif
;;;		Lisp57b.Gif
;;;		Lisp57c.Gif
;;;		AfraLisp.Gif
;;;		Image4.Gif
;;;		Sample.Lsp
;;;		Sample1.Lsp
;;;
;;;  ----------------------------------------------------------------
;;;
;;;		Version 1.0 Dated 20th September 1999
;;;		      Written by Kenny Ramage
;;;		  E-Mail : kramage@namdeb.com.na
;;;	    	   kenny@afralisp.hypermart.net
;;;		     Tel No : 09264-63-235837
;;;
;;;  ----------------------------------------------------------------

(prompt "\n Type INIT to run....")

;;;  ----------------------------------------------------------------

(defun C:INIT (/ THELIST USERFLAG USERFLAG1 USERFLAG2 HE INF)

  (setq	THELIST	'("Select O.K. to Initialize."
		  "***********************************"
		  "Next, Load and Run Your"
		  "AutoLisp Routine."
		  "***********************************"
		  "Then Type 'LISTVAR' to List"
		  "all Variables (Un-Declared)"
		  "and all User Functions."
		  "***********************************"
		  "Select 'Print to File' to Save"
		  "the Variable/Function List."
		  "***********************************"
		  )
	) ;_ end of setq

  (setq DCL_ID (load_dialog "listvar.dcl"))


  (if (not (new_dialog "run" DCL_ID)

	   ) ;_ end of not

    (exit)

    ) ;_ end of if

  (start_list "selections1")

  (mapcar 'add_list THELIST)

  (end_list)

  (action_tile

    "accept"

    "(done_dialog) (setq userflag T)"

    ) ;_ end of action_tile

  (action_tile

    "cancel"


    "(done_dialog) (setq userflag nil)"

    ) ;_ end of action_tile

  (action_tile
    "help"

    "(done_dialog) (setq userflag1 T)"

    ) ;_ end of action_tile

  (action_tile
    "info"

    "(done_dialog) (setq userflag2 T)"

    ) ;_ end of action_tile

  (start_dialog)

  (unload_dialog DCL_ID)

  (if USERFLAG

    (setq FUNC_LIST (atoms-family 1))

    ) ;_ end of if

  (if USERFLAG1

   (HEL)

  )

  (IF USERFLAG2

   (IN)

  )

  (princ)

  ) ;_ end of defun

;;;  ----------------------------------------------------------------

(defun C:LISTVAR (/ CNT ITEM ITEM1 TEMP FNAME THING DCL_ID)

  (setq FUNC_LIST1 (atoms-family 1))

  (setq L1 (length FUNC_LIST))

  (setq L2 (length FUNC_LIST1))

  (setq CNT 0)

  (repeat L2

    (setq ITEM (list (nth CNT FUNC_LIST1)))

    (setq ITEM1 (nth CNT FUNC_LIST1))

    (if	(not (member ITEM1 FUNC_LIST))

      (if (not (= ITEM1 "FUNC_LIST"))

	(setq MAINLIST (append ITEM MAINLIST))

	) ;_ end of if

      ) ;_ end of if

    (setq CNT (1+ CNT))

    ) ;_ end of repeat

  (setq MAINLIST (acad_strlsort MAINLIST))

  (setq DCL_ID (load_dialog "listvar.dcl"))

  (if (not (new_dialog "listvar" DCL_ID)

	   ) ;_ end of not

    (exit)

    ) ;_ end of if

  (start_list "selections")

  (mapcar 'add_list MAINLIST)

  (end_list)

  (action_tile

    "btn1"

    "(wfile)"

    ) ;_ end of action_tile

  (action_tile

    "accept"

    "(done_dialog)"

    ) ;_ end of action_tile

  (action_tile

    "cancel"

    "(done_dialog)"

    ) ;_ end of action_tile

  (start_dialog)

  (unload_dialog DCL_ID)

  (setq MAINLIST NIL)

  (setq FUNC_LIST1 NIL)

  (princ)

  ) ;_ end of defun

;;;  ----------------------------------------------------------------

(defun WFILE ()

  (setq FNAME "ListVar.txt")

  (setq TEMP (open FNAME "w"))

  (foreach THING MAINLIST (write-line THING TEMP))

  (close TEMP)

  (set_tile "txt1"

	    "    Variable/Function List Written to File"

	    ) ;_ end of set_tile

  (set_tile "txt2"

	    "               File : ListVar.Txt"

	    ) ;_ end of set_tile

  ) ;_ end of defun

(defun hel ()

  	(setq HE (findfile "ListVar.htm"))

	(command "Browser" HE)
)

(defun in ()

  	(setq inf (findfile "Info.htm"))

	(command "Browser" inf)
)




(princ)

;;;EOF
;;;  ----------------------------------------------------------------
